<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="wa-configure-dropping">
  <title>Controlling the Behavior of Drag/Drop Operations</title>
  <prolog>
    <metadata>
      <keywords>
        <indexterm>Configuring drag/drop</indexterm>
      </keywords>
    </metadata>
  </prolog>
  <body>
    <p id="p_kbt_dgk_54b">By default, dragging a valid URL string and dropping it into the editor in <ph
        keyref="webappProduct"/> will automatically insert it as a link element for the particular
      document type you are working with. For example, in DITA it would insert an
        <codeph>xref</codeph> element.</p>
    <p id="p_lbt_dgk_54b">If an HTML element that represents a file from a side-view or a CMS window is dragged, you
      can make <ph keyref="webappProduct"/> insert links to that file when the element is dropped in
      the editor. This can be done by writing JavaScript code that lets <ph keyref="webappProduct"/>
      know that the dropped element represents a reference to a file. </p>
    <p id="p_mbt_dgk_54b">This code should set a listener on the <codeph>dragstart</codeph> event
      for the type of items that can be dragged. On the handler for the <codeph>dragstart</codeph>
      event, you can set the <b>application/oxy-reference</b> custom type to the event's
        <codeph>dataTransfer</codeph> object.</p>
    <p id="p_obt_dgk_54b">The value of this custom type needs to be a string before being added to
        <codeph>dataTransfer</codeph>.</p>
    <p id="p_pbt_dgk_54b">The object must contain the following properties:<ul id="ul_qbt_dgk_54b">
        <li id="li_rbt_dgk_54b"><b>type</b> - The reference type to insert. One of the following
            values:<ul id="ul_vlx_vwr_1rb">
            <li><codeph>FILE_REFERENCE</codeph> - The URL points to an arbitrary file inside the
              same project.</li>
            <li><codeph>IMAGE_REFERENCE</codeph> - The URL points to an image.</li>
            <li><codeph>WEB_REFERENCE</codeph> - The URL points to an external resource.</li>
            <li><codeph>XML_REFERENCE</codeph> - The URL points to an XML file.</li>
          </ul></li>
        <li id="li_sbt_dgk_54b"><b>url</b> - The <xref href="oxy-url.dita">OXY-URL</xref> that the reference points
          to.</li>
      </ul></p>
    <p id="p_tbt_dgk_54b">An example of adding custom data on the <codeph>dragstart</codeph> event handler should look
      like
      this:<codeblock  id="codeblock_ubt_dgk_54b">// type needs to be set to 'text' for IE only.
var type = 'application/oxy-reference'; 
e.dataTransfer.setData(type, JSON.stringify({ 
  url: 'http://example_url.com', 
  type: 'xml_reference' 
}));</codeblock></p>
    <p id="p_vbt_dgk_54b">To customize what element gets inserted when a link is dropped, one can use the
        <codeph>ro.sync.ecss.extensions.api.AuthorExternalObjectInsertionHandler</codeph> Java
      API.</p>
  </body>
</topic>
